<?php 

namespace Teknisa\DF\Modules\Entrada\Services;

/* Bibliotecas */
use NFePHP\NFe\Common\Config;
use NFePHP\CTe\Tools as CTe;

use Doctrine\ORM\EntityManager;
use Geral\Entities\Empresa;
use Geral\Entities\Inscrestad;
use NFePHP\Common\Certificate;
/*use NFePHP\Common\Configure\Configure;
use NFePHP\Common\Exception\RuntimeException;
use NFePHP\Common\Files\FilesFolders;


use Teknisa\Libs\Util\DateUtil;*/
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\Masks\Masks;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Utilities;
/*use Teknisa\Model\Fiscal\Entities\Arqxmlnfe;
use Teknisa\Model\Fiscal\Entities\Notadestinada;
use Teknisa\Model\Fiscal\Entities\Notafiscal;
use Teknisa\Model\Fiscal\Entities\Lotenfe;
use Teknisa\Model\Geral\Entities\Paramempresa;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;*/

/* Classes DF */
use Teknisa\DF\Modules\Entrada\Factories\Dfe71000SincronizacaoCTEFactory;
/*use Teknisa\DF\Services\TransmissaoNfeService;
use Teknisa\DF\Services\XmlNFeService;*/
use Teknisa\DF\Services\NFe\ReturnNFe;

class Dfe71000SincronizacaoCTEService {
    
    //const CONTADOR_NOVOCODIGO_SINCRONIZACAO    = 'SINCRONIZACAONFE';
    const CONTADOR_NOVOCODIGO_NOTAMANIFESTACAO = 'NOTAMANIFESTACAO';
    
    protected $sincronizacaoCTEFactory;
    protected $fileUploader;
    protected $novoCodigo;
    protected $entityManager;
    protected $environment;
    protected $transmissaoService;
    protected $connectionCustom;
    
    protected $cteTools;
    protected $aResposta = [];
    
    protected $notas = array();
    protected $notasEncontradas = [];
    protected $notasParaDownload = [];
    protected $quantidadeEventos;
    /*protected $quantidadeNotas;
    protected $importacaoPendente = array();
    protected $notasDownload;
    protected $sincronizadas;
    
    protected $chaves = array();
    protected $notasInexistentes = array();
    protected $xmlsNota = array();*/
    
    public function __construct(Dfe71000SincronizacaoCTEFactory $sincronizacaoCTEFactory, $novoCodigo, $entityManager, $environment, $fileServerLink, $connectionCustom) {
        $this->sincronizacaoCTEFactory = $sincronizacaoCTEFactory;
        $this->novoCodigo           = $novoCodigo;
        $this->entityManager        = $entityManager;
        $this->environment          = $environment;
        $this->masks = new Masks();
        $this->fileServerLink       = $fileServerLink;
        $this->connectionCustom = $connectionCustom;
        set_time_limit(0);
    }
    
    public function sincronizarCte($config, $params){
        $config = json_decode(json_encode($config));
        $object_config = $config;
        
    	$tools = $this->getToolsNFe($object_config->ie, $object_config->cnpj, json_encode($config));
    	$this->cteTools = $tools;
        
        $cnpj = $object_config->cnpj;
        $existeNotas = true;
        if(empty($params['CDINSCESTA']) && !empty($object_config->ie)){
            $params['CDINSCESTA'] = $object_config->ie;
        }
        
        //$ultNSU = 0; //REMOVER!!!
        $ultNSU = $this->sincronizacaoCTEFactory->maxNrNsu($cnpj, $object_config->tpAmb);
        
        $ultNSU = (!$ultNSU) ? 0 : $ultNSU;
        $ultNSU = str_pad($ultNSU, 15, "0", STR_PAD_LEFT);

        $count  = 0; $this->quantidadeEventos = 0; /*$this->quantidadeNotas = 0; $this->notasDownload = 0; $this->sincronizadas = 0;
        $this->chaves = []; $this->notas = []; $this->notasInexistentes = []; $this->importacaoPendente = [];*/
        $notas = []; $erros = []; $this->notasEncontradas = []; $this->notasParaDownload = [];
        //$atualizaIdConsultado = true;
        $connection = $this->entityManager->getConnection();
        
        do {
            try {
                $this->buscaNotasSefaz($ultNSU, 0, $cnpj);
                $notas = $this->aResposta;
                
                $connection->beginTransaction();
                //$nrSincronizacaoNfe = $this->novoCodigo->getCodeByTableName(self::CONTADOR_NOVOCODIGO_SINCRONIZACAO.$object_config->cnpj, $this->environment->getNrOrgTrab());
                //$this->sincronizacaoCTEFactory->insereHoraSincronizacao($object_config->cnpj, $nrSincronizacaoNfe, $this->environment->getCdOperador(), $ultNSU, $this->environment->getNrOrgTrab());
                $this->trataRetornoLoteSincronizacao($cnpj, $notas, $object_config, $params, '');
                
                $connection->commit();
            }
            catch(\Exception $e) {
                if($e->getCode() === 137) {
                    if($count == 0) {
                        throw new \Exception($e->getMessage(), $e->getCode()); //Nenhum documento localizado.
                    }
                    $existeNotas = false;
                    break;
                }
                else if($e->getCode() === 656){
                    throw new \Exception($e->getMessage(), $e->getCode()); ////Consumo indevido.
                }
                else if(strpos($e->getMessage(), "Certificate") !== false){
                    $connection->rollback();
                    throw new \Exception("Certificado vencido. ".$e->getMessage());
                }
                

                $connection->rollback();
                $erros[] = $e->getMessage();
            }
            
            if(isset($notas["ultNSU"]) && isset($notas["maxNSU"]) && isset($notas["cStat"])) {
               if($notas["cStat"] == 656 || $count > 11) { // Rejeição 656: Consumo Indevido.
                  $existeNotas = false;
                  break;
               }
                else if($notas["ultNSU"] != $notas["maxNSU"]) {
                    $ultNSU = $notas["ultNSU"];
                    $count++;
                }
                else {
                    $existeNotas = false;
                    break;
                }
            }
            else {
                $existeNotas = false;
                break;
            }
        } while($existeNotas === true);
        
        //$this->downloadAutomaticoXML($this->notasEncontradas, $object_config);
        
        /*$chavesRetorno = array();
        foreach($this->chaves as $chave) {
            $chavesRetorno[] = $chave;
        }
        */
        //return array("CHAVES" => $chavesRetorno, "DADOS" => $this->calculaDadosSincronizacao($this->notas), "ERROS" => $erros);
        
        return array("DADOS" => $this->calculaDadosSincronizacao(), "ERROS" => $erros);
    }
    
    public function montaConfigCte($empresa, $organizacao, $inscricao, $cnpj) {
        $objEmpresa = $this->entityManager->getRepository('Geral\Entities\Empresa')->findOneBy(['cdempresa' => $empresa, 'nrorg' => $organizacao]);
        
        $cnpj = $this->masks->removeMascaraInscricao($cnpj);
        
        $razaosocial = trim($this->masks->replaceCharsForParser($this->masks->removeAcentos($objEmpresa->getNmrazsocempr())));
        $nomefantasia = $razaosocial;
        
        if(!empty($inscricao)) {
            if(strpos("ISENTO",strtoupper($inscricao)) || strpos("ISENTA", strtoupper($inscricao))){
                $ie = "ISENTO";
            }
            else{
                $ie = str_replace(" ", "", $this->masks->removeMascaraInscricao($this->masks->removeAcentos($inscricao)));
            }
            $inscrestad = self::getInscricaoEstadual($empresa, $organizacao, $inscricao, $cnpj);
        }
        else{
            $inscrestad = $this->entityManager->getRepository('Geral\Entities\Inscrestad')->findBy(['cdempresa' => $empresa, 'nrinsjuriest' => $cnpj, 'nrorg' => $organizacao]);

            if(empty($inscrestad)) throw new \Exception('Inscrição Estadual não Encontrada');
            else{
                $ieComCertificados = array_filter($inscrestad, function($certRow){
                    return !empty($this->sincronizacaoCTEFactory->getCertificado($certRow->getCdinscesta(), $certRow->getNrinsjuriest()));
    		    });
    		    
    		    if(empty($ieComCertificados)) throw new \Exception('Certificado Digital não Encontrado');
    		    else{
    		        $inscrestad = $ieComCertificados[0];
    		        $ie = $inscrestad->getCdinscesta();
    		    }
            }
        }
        $tpAmb = (int) $inscrestad->getIdtpambientenfe(); // 1-Produção 2-Homologação
        $siglaUF = $objEmpresa->getSgestado();
        $config = [
            "tpAmb"       => $tpAmb,
            "razaosocial" => $nomefantasia,
            "siglaUF"     => $siglaUF,
            "cnpj"        => $cnpj,
            "schemes"     => "PL_CTe_300a",
            "versao"      => "3.00",
            "ie"          => $ie,
            "cdempresa"   => $empresa,
            "nrorg"       => $this->environment->getNrOrgTrab()];
        
        $resp = Config::validate(json_encode($config));
        return $resp;
    }
     /**
     * Retorna inscricao estadual da empresa
     * @param $empresa
     * @param $cdinscestad
     * @param $organizacao
     * @return Inscrestad
     * @throws \Exception
     */
    private function getInscricaoEstadual($empresa, $organizacao, $inscricao, $cnpj){
        $inscrestad = $this->entityManager->getRepository('Geral\Entities\Inscrestad')->findOneBy(
                        ['cdempresa' => $empresa, 'nrinsjuriest' => $cnpj, 'nrorg' => $organizacao, 'cdinscesta'=> $inscricao]);
        
        if (!($inscrestad instanceof Inscrestad)) throw new \Exception('Inscrição Estadual não Encontrada');

        return $inscrestad;
    }
    
    private function downloadAutomaticoXML($operador, $config) {
		$tpAmb = $config->tpAmb;
        $notasDownload = $this->sincronizacaoCTEFactory->getNotasDownloadAutomatico($config->cnpj, $tpAmb);
        $diretorioIntegracao = $this->sincronizacaoCTEFactory->getDiretorioIntegracao();
        
		foreach($notasDownload as $nota) {

			$this->aResposta = array();
			
			$notaBaixada = $this->cteTools->sefazDownload($nota["NRACESSONFE"], $tpAmb, $this->aResposta);
            
			if(!isset($notaBaixada) || ! $notaBaixada) {
			    $this->manifestaNfe($nota, '210210', '', $config);
    			$notaBaixada = $this->cteTools->sefazDownload($nota["NRACESSONFE"], $tpAmb, $this->aResposta);
			}
    		try {
			    $chave = $nota["NRACESSONFE"];
    			if(isset($notaBaixada)) {
    			    if($notaBaixada) {

        			    $notaBaixada = ReturnNFe::readReturnSefaz('NfeDistribuicaoDFe', $notaBaixada);
        			    if(isset($notaBaixada["aDoc"][0])) {
    
        			        if(isset($notaBaixada["aDoc"][0]["doc"])) {
        			            if(substr($notaBaixada["aDoc"][0]["schema"], 0 , 7) == 'procNFe') {
            			            $notaBaixada = $notaBaixada["aDoc"][0]["doc"];
            			            if($this->environment->getNrOrgTrab() != 1) {
            			                if(!isset($this->sincronizacaoCTEFactory->existeNotaRelac($chave)[0])) {
                            			    $this->sincronizacaoCTEFactory->zGravaFile($tpAmb, $nota["NRACESSONFE"].'.xml', $notaBaixada, 
                        			                                    'importar/', $config->cnpj, $config->ie, $nota["NRACESSONFE"]);
            			                }
                                        $this->notasDownload++;
                            			if(!isset($this->chaves[$chave])) {
                            			    $this->chaves[$chave] = $chave;
                            			}
                        			}
                        			else {
                    			        if(isset($diretorioIntegracao[0])) {
                    			            
                    			            if($diretorioIntegracao[0]["DSDIRIMPARQXML"] != null) {
                    			                if(is_file($diretorioIntegracao[0]["DSDIRIMPARQXML"]."/$chave.xml")) {
                        			                file_put_contents($diretorioIntegracao[0]["DSDIRIMPARQXML"]."/$chave.xml", $notaBaixada);
                        			                $this->notasDownload++;
                                        			if(!isset($this->chaves[$chave])) {
                                        			    $this->chaves[$chave] = $chave;
                                        			}
                    			                }
                    			                else {
                        			                file_put_contents($diretorioIntegracao[0]["DSDIRIMPARQXML"]."/$chave.xml", $notaBaixada);
                        			                $this->notasDownload++;
                                        			if(!isset($this->chaves[$chave])) {
                                        			    $this->chaves[$chave] = $chave;
                                        			}
                    			                }
                    			            }
                    			        }
                        			    
                        			}
        			            }
        			        }
        			    }
    			    }
    			}
			}
		    catch(\Exception $e) {
		        //var_dump('catch downloadAutomaticoXML', $e->getMessage());
		    }
        //    $this->sincronizacaoCTEFactory->atualizaNDownloads($config->cnpj, $chave, $nota["NRNSU"]);
		}
    }

    public function preencheTabelasSincManifestacao($sincronizacao, $config){
        try {
            $connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
            foreach ($sincronizacao['aDoc'] as $doc) {
                $nsu = $doc['NSU'];
                $ultNSU = $sincronizacao['ultNSU'];
                $xml                    = new \DOMDocument();
                $xml->preservWhiteSpace = false; //elimina espacos em branco
                $xml->formatOutput      = false;
                $xml->loadXML($doc['doc']);
                $arrayXml = $this->converteXmlParaArray($xml->saveXML());
                
                $chave = $xml->getElementsByTagName('chCTe')->item(0)->nodeValue;
                $cStat = $xml->getElementsByTagName('cStat')->item(0)->nodeValue;
                
                if(!empty($chave)) {
                    if($doc['schema'] == 'procCTe_v3.00.xsd' || $doc['schema'] == 'cteOSProc_v3.00.xsd') {
                        
                        if(!isset($this->notasEncontradas[$chave])) {
                	        $this->notasEncontradas[$chave] = $chave;
                	    }
                	    if($cStat == 100) {
                	        if(!isset($this->notasParaDownload[$chave])) {
                    	        $this->notasParaDownload[$chave] = $chave;
                    	    }
                	    }
                	    $this->preencheNotaCte($config, $arrayXml, $chave, $nsu, $doc['schema']);
                	    $this->pesquisaCteAceitos($chave);
                    }
                    else if($doc['schema'] == 'procEventoCTe_v3.00.xsd') {
                        
                        $this->preencheNotaCte($config, $arrayXml, $chave, $nsu, $doc['schema']);
                        $this->quantidadeEventos++;
                    }
                }
            }
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

    private function preencheNotaCte($config, $arrayXml, $chave, $nsu, $schema){
        $existeNotaCte = $this->sincronizacaoCTEFactory->existeNotaCte($nsu, $config->cnpj, $config->tpAmb);
        
             if($schema == 'procCTe_v3.00.xsd')       $dadosCte = $this->preparaDadosProcCTe($chave, $arrayXml, $nsu, $config->cnpj);
        else if($schema == 'cteOSProc_v3.00.xsd')     $dadosCte = $this->preparaDadosCTeOSProc($chave, $arrayXml, $nsu, $config->cnpj);
        else if($schema == 'procEventoCTe_v3.00.xsd') $dadosCte = $this->preparaDadosProcEventoCTe($chave, $arrayXml, $nsu, $config->cnpj);
        
        if(empty($existeNotaCte) && !empty($dadosCte)){
            $this->atualizaNSUFaltante($config->cnpj, $config->tpAmb, $nsu);
            $this->sincronizacaoCTEFactory->incluirNotaCte($dadosCte);
        }
        else if(!empty($dadosCte)){
            $this->sincronizacaoCTEFactory->atualizaNotaCte($dadosCte);
        }
    }
    
    private function preparaDadosProcCTe($nracessocte, $arrayXml, $nsu, $cnpj) {
        $CTe = $arrayXml['CTe'];
        $infCte = $CTe['infCte'];
        $ide = $infCte['ide'];
        $emit = $infCte['emit'];
        $rem   = isset($infCte['rem']) ? $infCte['rem'] : null;
        $exped = isset($infCte['exped']) ? $infCte['exped'] : null;
        $receb = isset($infCte['receb']) ? $infCte['receb'] : null;
        $dest = isset($infCte['dest']) ? $infCte['dest'] : null;
        
        $idtpambiente = $ide['tpAmb'];
        $dtEmissao = date('d/m/Y', strtotime(substr($ide["dhEmi"], 0, 19)));
        $vrtotalprest = $infCte['vPrest']['vTPrest'];
        $vrreceber = $infCte['vPrest']['vRec'];
        $cdstatus = $arrayXml['protCTe']['infProt']['cStat'];
        $dsstatus = $arrayXml['protCTe']['infProt']['xMotivo'];
        $nrinsjurreme = null; $nmrazsocreme = null; $nrinsjurexpe = null; $nmrazsocexpe = null; $nrinsjurrece = null;
        $nmrazsocrece = null; $nrinsjurdest = null; $nmrazsocdest = null;
        
        /*EMITENTE*/
            $nrinsjuremit = $emit['CNPJ'];
            $nmrazsocemit = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($emit['xNome'])));
        /*REMETENTE*/
        if(isset($rem)) {
            $nrinsjurreme = isset($rem['CNPJ']) ? $rem['CNPJ'] : $rem['CPF'];
            $nmrazsocreme = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($rem['xNome'])));
        }
        /*EXPEDIDOR*/
        if(isset($exped)) {
            $nrinsjurexpe = isset($exped['CNPJ']) ? $exped['CNPJ'] : $exped['CPF'];
            $nmrazsocexpe = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($exped['xNome'])));
        }
        /*RECEBEDOR*/
        if(isset($receb)) {
            $nrinsjurrece = isset($receb['CNPJ']) ? $receb['CNPJ'] : $receb['CPF'];
            $nmrazsocrece = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($receb['xNome'])));
        }
        /*DESTINATÁRIO*/
        if(isset($dest)) {
            $nrinsjurdest = isset($dest['CNPJ']) ? $dest['CNPJ'] : $dest['CPF'];
            $nmrazsocdest = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($dest['xNome'])));
        }
        /*TOMADOR*/
        if(isset($ide['toma3'])) {
            $idtomador = $ide['toma3']['toma'];
            
            switch($ide['toma3']['toma']) {
                case 0:
                    $nrinsjurtoma = $nrinsjurreme;
                    $nmrazsoctoma = $nmrazsocreme;
                    break;
                case 1:
                    $nrinsjurtoma = $nrinsjurexpe;
                    $nmrazsoctoma = $nmrazsocexpe;
                    break;
                case 2:
                    $nrinsjurtoma = $nrinsjurrece;
                    $nmrazsoctoma = $nmrazsocrece;
                    break;
                case 3:
                    $nrinsjurtoma = $nrinsjurdest;
                    $nmrazsoctoma = $nmrazsocdest;
                    break;
            }
        } else {
            $idtomador = 4;
            $nrinsjurtoma = isset($ide['toma4']['CNPJ']) ? $ide['toma4']['CNPJ'] : $ide['toma4']['CPF'];
            $nmrazsoctoma = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($ide['toma4']['xNome'])));
        }
        
        return ["NRACESSOCTE"  => $nracessocte,  "NSU"          => $nsu,          "NRINSJURPESQ" => $cnpj,         "IDTPAMBIENTE" => $idtpambiente,
                "DTEMISSAO"    => $dtEmissao,    "VRTOTALPREST" => $vrtotalprest, "VRRECEBER"    => $vrreceber,    "CDSTATUS"     => $cdstatus,
                "DSSTATUS"     => $dsstatus,     "NRINSJUREMIT" => $nrinsjuremit, "NMRAZSOCEMIT" => $nmrazsocemit, "NRINSJURREME" => $nrinsjurreme,
                "NMRAZSOCREME" => $nmrazsocreme, "NRINSJUREXPE" => $nrinsjurexpe, "NMRAZSOCEXPE" => $nmrazsocexpe, "NRINSJURRECE" => $nrinsjurrece,
                "NMRAZSOCRECE" => $nmrazsocrece, "NRINSJURDEST" => $nrinsjurdest, "NMRAZSOCDEST" => $nmrazsocdest, "IDTOMADOR"    => $idtomador,
                "NRINSJURTOMA" => $nrinsjurtoma, "NMRAZSOCTOMA" => $nmrazsoctoma];
    }
    
    private function preparaDadosCTeOSProc($nracessocte, $arrayXml, $nsu, $cnpj) {
        $CTeOS = $arrayXml['CTeOS'];
        $infCte = $CTeOS['infCte'];
        $ide = $infCte['ide'];
        $emit = $infCte['emit'];
        $toma = isset($infCte['toma']) ? $infCte['toma'] : null;
        
        $idtpambiente = $ide['tpAmb'];
        $dtEmissao = date('d/m/Y', strtotime(substr($ide["dhEmi"], 0, 19)));
        $vrtotalprest = $infCte['vPrest']['vTPrest'];
        $vrreceber = $infCte['vPrest']['vRec'];
        $cdstatus = $arrayXml['protCTe']['infProt']['cStat'];
        $dsstatus = $arrayXml['protCTe']['infProt']['xMotivo'];
        
        /*EMITENTE*/
        $nrinsjuremit = $emit['CNPJ'];
        $nmrazsocemit = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($emit['xNome'])));
        /*REMETENTE*/
        $nrinsjurreme = null; $nmrazsocreme = null;
        /*EXPEDIDOR*/
        $nrinsjurexpe = null; $nmrazsocexpe = null;
        /*RECEBEDOR*/
        $nrinsjurrece = null; $nmrazsocrece = null;
        /*DESTINATÁRIO*/
        $nrinsjurdest = null; $nmrazsocdest = null;
        /*TOMADOR*/
        $idtomador = null; $nrinsjurtoma = null; $nmrazsoctoma = null;
        if(isset($toma)) {
            $nrinsjurtoma = isset($ide['toma']['CNPJ']) ? $ide['toma']['CNPJ'] : $ide['toma']['CPF'];
            $nmrazsoctoma = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($ide['toma']['xNome'])));
        }
        
        return ["NRACESSOCTE"  => $nracessocte,  "NSU"          => $nsu,          "NRINSJURPESQ" => $cnpj,         "IDTPAMBIENTE" => $idtpambiente,
                "DTEMISSAO"    => $dtEmissao,    "VRTOTALPREST" => $vrtotalprest, "VRRECEBER"    => $vrreceber,    "CDSTATUS"     => $cdstatus,
                "DSSTATUS"     => $dsstatus,     "NRINSJUREMIT" => $nrinsjuremit, "NMRAZSOCEMIT" => $nmrazsocemit, "NRINSJURREME" => $nrinsjurreme,
                "NMRAZSOCREME" => $nmrazsocreme, "NRINSJUREXPE" => $nrinsjurexpe, "NMRAZSOCEXPE" => $nmrazsocexpe, "NRINSJURRECE" => $nrinsjurrece,
                "NMRAZSOCRECE" => $nmrazsocrece, "NRINSJURDEST" => $nrinsjurdest, "NMRAZSOCDEST" => $nmrazsocdest, "IDTOMADOR"    => $idtomador,
                "NRINSJURTOMA" => $nrinsjurtoma, "NMRAZSOCTOMA" => $nmrazsoctoma];
    }
    
    private function preparaDadosProcEventoCTe($nracessocte, $arrayXml, $nsu, $cnpj) {
        
        $cteAceitos = $this->sincronizacaoCTEFactory->pesquisaCteAceitos($nracessocte);
        
        if($cteAceitos) {
            $idtpambiente = $arrayXml['retEventoCTe']['infEvento']['tpAmb'];
            $dtEmissao = $cteAceitos['DTEMISSAO'];
            $vrtotalprest = $cteAceitos['VRTOTALPREST'];
            $vrreceber = $cteAceitos['VRRECEBER'];
            $cdstatus = $arrayXml['retEventoCTe']['infEvento']['cStat'];
            $dsstatus = $arrayXml['retEventoCTe']['infEvento']['xMotivo'];
            
            /*EMITENTE*/
            $nrinsjuremit = $cteAceitos['NRINSJUREMIT'];
            $nmrazsocemit = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($cteAceitos['NMRAZSOCEMIT'])));
            /*REMETENTE*/
            $nrinsjurreme = $cteAceitos['NRINSJURREME'];
            $nmrazsocreme = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($cteAceitos['NMRAZSOCREME'])));
            /*EXPEDIDOR*/
            $nrinsjurexpe = $cteAceitos['NRINSJUREXPE'];
            $nmrazsocexpe = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($cteAceitos['NMRAZSOCEXPE'])));
            /*RECEBEDOR*/
            $nrinsjurrece = $cteAceitos['NRINSJURRECE'];
            $nmrazsocrece = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($cteAceitos['NMRAZSOCRECE'])));
            /*DESTINATÁRIO*/
            $nrinsjurdest = $cteAceitos['NRINSJURDEST'];
            $nmrazsocdest = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($cteAceitos['NMRAZSOCDEST'])));
            /*TOMADOR*/
            $idtomador = $cteAceitos['IDTOMADOR'];
            $nrinsjurtoma = $cteAceitos['NRINSJURTOMA'];
            $nmrazsoctoma = trim($this->replaceCharsForParserInverted($this->masks->removeAcentos($cteAceitos['NMRAZSOCTOMA'])));
            
            return ["NRACESSOCTE"  => $nracessocte,  "NSU"          => $nsu,          "NRINSJURPESQ" => $cnpj,         "IDTPAMBIENTE" => $idtpambiente,
                    "DTEMISSAO"    => $dtEmissao,    "VRTOTALPREST" => $vrtotalprest, "VRRECEBER"    => $vrreceber,    "CDSTATUS"     => $cdstatus,
                    "DSSTATUS"     => $dsstatus,     "NRINSJUREMIT" => $nrinsjuremit, "NMRAZSOCEMIT" => $nmrazsocemit, "NRINSJURREME" => $nrinsjurreme,
                    "NMRAZSOCREME" => $nmrazsocreme, "NRINSJUREXPE" => $nrinsjurexpe, "NMRAZSOCEXPE" => $nmrazsocexpe, "NRINSJURRECE" => $nrinsjurrece,
                    "NMRAZSOCRECE" => $nmrazsocrece, "NRINSJURDEST" => $nrinsjurdest, "NMRAZSOCDEST" => $nmrazsocdest, "IDTOMADOR"    => $idtomador,
                    "NRINSJURTOMA" => $nrinsjurtoma, "NMRAZSOCTOMA" => $nmrazsoctoma];
        }
    }
    
    private function pesquisaCteAceitos($nracessocte) {
        $cteAceitos = $this->sincronizacaoCTEFactory->pesquisaCteAceitos($nracessocte);
        if($cteAceitos) $this->sincronizacaoCTEFactory->atualizaCteAceitos($cteAceitos);
    }
    
    private function preencheEventoNotadestinada($notadestinada, $config, $xml, $chave, $docEvento, $existeTpEvento){
        $nota = $this->converteXmlParaArray($xml->saveXML());
        $correcao = false;
        $dsOperacao = '';
        if($existeTpEvento) $tpEvento = $xml->getElementsByTagName('tpEvento')->item(0)->nodeValue;
        else $tpEvento = '100';
        if($notadestinada) {
            if($tpEvento === '110111') {
                $idTpEvento  = '1';
                $idStatusNfe = '3'; 
                $dsOperacao  = "Nota fiscal cancelada pelo destinatário.";        
                $dtRecbto = $nota["retEvento"]["infEvento"]["dhRegEvento"];
                $dtRecbto = date('d/m/Y H:i:s', strtotime(substr($dtRecbto, 0, 19)));
                $existeNotaDestinada = $this->sincronizacaoCTEFactory->existeNotaDestinada($chave);
                
                if(isset($existeNotaDestinada[0])){
                    $this->sincronizacaoCTEFactory->atualizaNotaCte($idStatusNfe, '', $dtRecbto, $chave);
                }
                else{
                    $nrProxNotadestinada = $this->novoCodigo->getCodeByTableName(self::CONTADOR_NOVOCODIGO_NOTAMANIFESTACAO, $config->nrorg);
                    $this->sincronizacaoCTEFactory->incluirNotadestinada($nrProxNotadestinada, '', $chave, '', '',
                                    '', '', '', '', '', '', $idStatusNfe,
                                    '', '', null, null, null, null, null, '', null, '', '', '', '', '', $this->environment->getNrOrgTrab());    
                } 
                $this->quantidadeEventos++;
            }
            else if($tpEvento === '110110') {
                $idTpEvento  = '2';
                $idStatusNfe = '0';
                $dsOperacao  = "Evento de carta de correção registrado para a nota fiscal ".$nota["evento"]["infEvento"]["detEvento"]["xCorrecao"];
                $dtHrEvento  = date('d/m/Y', strtotime(substr($nota["retEvento"]["infEvento"]["dhRegEvento"], 0, 19)));
                $dsCorrecaoNfe = $nota["evento"]["infEvento"]["detEvento"]["xCorrecao"];
                $nrSeqEvento = $this->sincronizacaoCTEFactory->getNrSeqEvento($chave)[0]["NRSEQEVENTO"]; 
                $correcao = true;
                $this->sincronizacaoCTEFactory->atualizaEventoNotadestinada(null, null, null, 2, $dtHrEvento, $nrSeqEvento, $dsCorrecaoNfe ,$chave);
                $this->quantidadeEventos++;
            }
            else if($tpEvento == '210200' 
                || $tpEvento  == '210210'
                || $tpEvento  == '210220'
                || $tpEvento  == '210240') {
                
                $idTpEvento  = '3';
                $idStatusNfe = '1';
            }
            else {
                $idStatusNfe = '0'; 
                $idTpEvento  = '0';
            }
            
            $sequencial = $this->sincronizacaoCTEFactory->getSequencialHistoricoXML($chave)[0]["NRSEQHISTOR"];
            if($sequencial === null) $sequencial = 1;
            else $sequencial += 1;
            $sequencial = str_pad($sequencial, 20, "0", STR_PAD_LEFT);
            
            $notaSincronizada = $this->sincronizacaoCTEFactory->getNotaSincronizada($chave);
            
            $cdFilial   = isset($notaSincronizada[0]) ? $notaSincronizada[0]["CDFILIAL"] : '';
            $nrLanctonf = isset($notaSincronizada[0]) ? $notaSincronizada[0]["NRLANCTONF"] : '';
            $idStatus   = isset($notaSincronizada[0]) ? 'S' : 'N';
            
            if($correcao === true) {
                $nProt      = $nota["retEvento"]["infEvento"]["nProt"];
            }
            else {
                try {
                    $nProt      = $nota["evento"]["infEvento"]["detEvento"]["nProt"];
                }
                catch(\Exception $e) {
                    $nProt      = $nota["retEvento"]["infEvento"]["nProt"];
                }
            }
            
            $tipoOper   = isset($this->sincronizacaoCTEFactory->buscaHistoricoXML($chave)[0]) ? 1 : 2;
            
            $this->sincronizacaoCTEFactory->insereHistoricoXML($chave, $sequencial, date('d/m/Y H:i:s'), $tipoOper, $idStatus, $nProt, $dsOperacao, $cdFilial, $nrLanctonf, $this->environment->getCdOperador(), $this->environment->getNrOrg());
        }
        // TODO 
        // Buscar nota destinada por chave de acesso caso não exista no sistema
    }

    public function manifestarNfe($notasfiscais, $config, $evento = '', $justificativa = '')  {
        $config = json_encode($config);
        $object_config = json_decode($config);
    	if(!isset($this->cteTools)) {
    		$tools = $this->getToolsNFe($object_config->ie, $object_config->cnpj, $config);
    		$this->cteTools = $tools;
        }
        
        $array_erros = array();
        foreach ($notasfiscais as $nota) {
            $erro = $this->manifestaNfe($nota, $evento, $justificativa, $config);
            if($erro) {
                $erro['NRLANCTONF'] = $nota['NRLANCTONF'];
                $erro['NRNOTAFISC'] = $nota['NRNOTAFISC'];
                array_push($array_erros, $erro);
            }
        }
        if(empty($array_erros)) return array("SUCESSO" => "Nota(s) manifestada(s) com sucesso.");
        else return array("ERRO" => $array_erros);
    }

    public function gerarXmlNfeManifestacao($notasfiscais, $config){
        $object_config = json_decode(json_encode($config));
        
    	if(!isset($this->cteTools)) {
    		$tools = $this->getToolsNFe($object_config->ie, $object_config->cnpj, json_encode($config));
    		$this->cteTools = $tools;
        }
        
        $existeNota = false;
        $dir = sys_get_temp_dir();
        $tpAmb = $object_config->tpAmb;

        $zipname = $dir.DIRECTORY_SEPARATOR.uniqid().'XMLs.zip';

        $zip = new \ZipArchive();
        

        if( $zip->open( $zipname , \ZipArchive::CREATE )  === true){
            foreach ($notasfiscais as $nota) {
                $notaDownload = $this->downloadNfe($nota, $dir, $tpAmb);
                
                if($notaDownload) {
                    $existeNota = true;
                    $zip->addFromString('NFe-'.$nota["NRACESSONFE"].'.xml' , file_get_contents($notaDownload));
                    unlink($notaDownload);
                }
            }
            $zip->close();
        }

        if(!$existeNota) {
            return false;
        }
        else {
            return $zipname;
        }
    }
    
    private function buscaNotasSefaz($ultNSU, $numNSU, $cnpj){
        $this->aResposta = [];
        $tpAmb = $this->cteTools->config->tpAmb;
        $resp = $this->cteTools->sefazDistDFe($ultNSU, $numNSU, 'AN', $this->aResposta);
        
        $this->aResposta = ReturnNFe::readReturnSefaz('NfeDistribuicaoDFe', $resp);
        
        return $this->aResposta;
    }

    private function manifestaNfe($nota, $tpEvento, $xJust, $config){
        $notaEntidade = $this->entityManager->getRepository('Teknisa\Model\Fiscal\Entities\Notadestinada')->findOneBy(
                            array('nracessonfe' => $nota['NRACESSONFE']));
        if(($tpEvento == "2" || $tpEvento == "3") && isset($notaEntidade)) {
            return array("CODIGO" => '', "MOTIVO" => "Nota existente no sistema. Não é possivel realizar operações
            do tipo \"Operação não realizada\" ou \"Desconhecimento da operação\".");
        }
        else {
            $this->aResposta = array();
            $chave = $nota['NRACESSONFE'];
            $tpAmb = $this->cteTools->config->tpAmb;
            
            switch($tpEvento) {
                case "1":
                    $tpEvento = "210200";
                    $dsOperacao    = "Operação Confirmada";
                    break;
                
                case "4": 
                    $idStatusManif = "210210";
                    $dsOperacao    = "Ciência da Emissão";
                    break;
                
                case "2":
                    $idStatusManif = "210220";
                    $dsOperacao    = "Operação Desconhecida";
                    break;
                    
                case "3":
                    $idStatusManif = "210240";
                    $dsOperacao    = "Operação Não Realizada";
                    break;
            }
            
            $eventos    = array("sucesso" => array(), "erro" => array());
            $xmlRetorno = $this->cteTools->sefazManifesta($chave, $tpEvento, $xJust, 1, $this->aResposta);
            
            $this->aResposta = ReturnNFe::readReturnSefaz('RecepcaoEvento', $xmlRetorno);
            
            return $this->trataLoteRetorno($this->aResposta, $xmlRetorno, $config, $tpEvento);
        }
        
    }

    private function trataLoteRetorno($loteRetorno, $xmlRetorno, $config, $tpEvento) {
        switch($tpEvento) {
            case "210200":
                $idStatusManif = "1";
                $dsOperacao    = "Operação Confirmada";
                break;
            
            case "210210": 
                $idStatusManif = "4";
                $dsOperacao    = "Ciência da Emissão";
                break;
            
            case "210220":
                $idStatusManif = "2";
                $dsOperacao    = "Operação Desconhecida";
                break;
                
            case "210240":
                $idStatusManif = "3";
                $dsOperacao    = "Operação Não Realizada";
                break;
        }

        // Verifica erro no lote
        if($loteRetorno['cStat'] == '128') {
            // Verifica erro nos eventos
            foreach ($loteRetorno['evento'] as $evento) {
                if($evento['cStat'] == '135' || ($evento['cStat'] == '136' && $evento['xMotivo'] == 'Evento registrado, mas nao vinculado a NF-e')) {
                    $notaDestinada = $this->entityManager->getRepository('Teknisa\Model\Fiscal\Entities\Notadestinada')->findOneBy(
                            array('nracessonfe' => $evento['chNFe']));
                    if($notaDestinada) {
                        $this->sincronizacaoCTEFactory->atualizaEventoNotadestinadaManifestada($notaDestinada, $evento, $idStatusManif, $xmlRetorno, $this->cteTools->config->cdempresa, $this->cteTools->config->nrorg);
                    }
                    else {
                        $this->sincronizacaoCTEFactory->incluirNotadestinadaManifestada($evento, $config, $idStatusManif, $xmlRetorno, $this->cteTools->config->cdempresa, $this->cteTools->config->nrorg);
                        $this->sincronizacaoCTEFactory->deletaNotaDuplicada($evento["chNFe"], $config->cnpj);
                    }
                    
                    $dadosNf =  $this->sincronizacaoCTEFactory->getDadosNf($evento['chNFe']);
                    if(isset($dadosNf[0])) {
                          if($dadosNf[0]["IDGERADAVIAXML"] == "S") {
                              $this->sincronizacaoCTEFactory->insereHistoricoXML($chave, $sequencial, date('d/m/Y H:i:s'), $tipoOper, $idStatus, $nProt, $dsOperacao, $cdFilial, $nrLanctonf, $this->environment->getCdOperador(), $this->environment->getNrOrg());
                          }
                    }
                }
                else {                    
                    $this->sincronizacaoCTEFactory->atualizaCdStatusManif($evento["chNFe"], $evento["cStat"]);
                    $erro = array($evento['cStat'], $evento['xMotivo'], $tpEvento);
                }
            }
            if(isset($erro)) {
                return array("CODIGO" => $evento['cStat'], "MOTIVO" => $evento['xMotivo']);
            }
        }
        else return array("CODIGO" => $loteRetorno['cStat'], "MOTIVO" => $loteRetorno['xMotivo']);
    }
    
    function formataData($date) {
        $dateDMY  = substr($date, 0, 10);
        $dateHIS  = substr($date, 11, 8);
        $formatedDate = explode('-', $dateDMY);
        $formatedDate = $formatedDate[0].'-'.$formatedDate[1].'-'.$formatedDate[2];
        $formatedDate.= ' '.$dateHIS;
        $formatedDate = strtotime($formatedDate);
        $formatedDate = date("d/m/Y H:i:s", $formatedDate);
        return DateUtil::getDataDeString($formatedDate, DateUtil::FORMATO_BRASILEIRO_DATAHORA);
    }

    private function downloadNfe($nota, $dir, $tpAmb){
        $this->aResposta = array();
        $chave = $nota["NRACESSONFE"];
        $nota = $this->cteTools->sefazDownload($chave, $tpAmb, $this->aResposta);
        
        $nota = ReturnNFe::readReturnSefaz('NfeDistribuicaoDFe', $nota);

        if(isset($nota)) {
            if(!empty($nota["aDoc"])) {
                file_put_contents($dir.DIRECTORY_SEPARATOR.$chave.'.xml', $nota["aDoc"][0]["doc"]);
                return $dir.DIRECTORY_SEPARATOR.$chave.'.xml';
            }
        }
        else {
            return false;
        }
        
    }

    private function recolocarArrobaEmail($config) {
        $config            = json_decode($config);
        $config->aMailConf = json_decode(str_replace("&#64", "@", json_encode($config->aMailConf)));
        $config            = json_encode($config);
        return $config;
    }
    
    /**
    *   Converte uma string Xml para um array.
    *    
    *   @param string $stringXml
    *   return  array - Array do XML
    */
    private function converteXmlParaArray($stringXml) {
        $xml = simplexml_load_string($stringXml);
        $json = json_encode($xml);
        $array = json_decode($json,TRUE);
        return $array;
    }
    
    private function calculaDadosSincronizacao() {
        $dadosSincronizacao = [];
        $dadosSincronizacao["NOTASPARADOWNLOAD"]   = $this->notasParaDownload;
        $dadosSincronizacao["QTNOTAS"]   = "Foram encontradas ".count($this->notasEncontradas)." nota(s) de CTE.";
        $dadosSincronizacao["QTEVENTOS"] = "Foram encontrados $this->quantidadeEventos eventos.";
        
        /*$dadosSincronizacao["QTINEXIST"] = "Existem ".count($this->notasInexistentes)." notas fiscais destinadas inexistentes no sistema.";
        $dadosSincronizacao["QTIMPORTP"] = "Existem ".count($this->importacaoPendente)." notas fiscais com importação de XML pendente.";
        $dadosSincronizacao["SINCRONIZ"] = "Foram atualizadas $this->sincronizadas notas fiscais existentes no sistema";
        $dadosSincronizacao["NOTASDOWN"] = "Download de $this->notasDownload arquivos XML realizado com sucesso";*/
        return $dadosSincronizacao;
    }

	public function getToolsNFe($ie, $cnpj, $config) {
	    
	    /*Função criada para buscar o cnpj vinculada a isncrição estadual, de forma que ele sempre busque o certificado correto*/
	    
	    $cnpjInscEstad = $this->sincronizacaoCTEFactory->getCNPJCertificado($ie, json_decode($config)->cdempresa);
	    $certificado = $this->sincronizacaoCTEFactory->getCertificado($ie, $cnpjInscEstad);
		$certificadoEncontrado = false;
		
		foreach($certificado as $cert) {
		    if($cert["DSDIRCERTIFICADO"]) {
		        $certificadoEncontrado = true;
		        $certify = $cert;
		    }
		}
		
		if($certificadoEncontrado == false) throw new \Exception("Certificado Digital não encontrado.");
		
        $senha = $this->decrypt($certify["CDSENHACERTIF"]);
		$certificado = $certify["DSDIRCERTIFICADO"];
		$certificado = explode('>', $certificado);
        $certificado = file_get_contents($this->fileServerLink.$certificado[1]);
        
        try {
            $certificado = Certificate::readPfx($certificado, $senha);
        }
        catch(\Exception $e) {
            throw new \Exception("Senha do certificado incorreta!");
        }
        $tools = new CTe($config, $certificado);
        
        return $tools;
	}
	
	private function decrypt($text, $salt = 'teknisa') {
	    return Utilities::zeedhiDecrypt($text, $salt);
    }
    
    public function getDefaultFilterManif($row) {
        $cdfilial = ($this->environment->getCdFilial()) ? $this->environment->getCdFilial() : $row["CDFILIAL"];
        $defaultFilter = $this->sincronizacaoCTEFactory->getDefaultFilterManif($cdfilial);
        $defaultFilter["DTEMISSAO"] = date("d/m/Y");
        return $defaultFilter;
    }
    
    public function nvl(&$var, $default = ""){
        return isset($var) ? $var
                           : $default;
    }
    
    private function trataRetornoLoteSincronizacao($cnpj, $notas, $object_config, $params, $nsu = '') {
        $cStat = $notas["cStat"];
        $xMotivo = $notas["xMotivo"];
        
        if($notas["cStat"] == 138) { //Documento localizado.
            
            $ultNSU = $notas["ultNSU"];
            $maxNsu = $notas["maxNSU"];
            /*if(!$nsu) {
                $this->insereNsuNfe($cnpj, $object_config->tpAmb, $ultNSU, $maxNsu);
            }*/
            $this->notas = array_merge($this->notas, $notas["aDoc"]);
            
            if(isset($notas["aDoc"])) {
                $this->preencheTabelasSincManifestacao($notas, $object_config);
                /*$atualizaIdConsultado = true;
                foreach($notas["aDoc"] as $notaFiscal) {
                    $nota = $this->converteXMLParaArray($notaFiscal["doc"]);
                    
                    $tipoEvento = false;
                    $tipoRes    = false;
                    $tipoNota   = false;
                    $tipoResEv  = false;
                    $data = $this->sincronizacaoCTEFactory->getDataHoraCerta();
                    if($atualizaIdConsultado && $params["FORMAPESQUISA"] == 1) {
                        //Esse processo de voltar o IDCONSULTADO para 'N' será necessário para poder realizar novamente a consulta de todos os NSU's
                        //quando o usuário optar por realizar a consulta dos últimos 3 meses.
                        $this->sincronizacaoCTEFactory->atualizaIdConsultado('N', $cnpj, $object_config->tpAmb, $notaFiscal["NSU"]);
                        $atualizaIdConsultado = false;
                    }
                    
                    // ProcEventoNfe
                    if(strtolower(substr($notaFiscal["schema"], 0, 13)) == strtolower('procEventoNFe')) {
                    	$infEvento = $nota["retEvento"]["infEvento"];
                    	$chave =  $infEvento["chNFe"];
                    	
                    	if($infEvento["tpEvento"] == '110111') { //110111: Tipo de Evento de Cancelamento.
                    	    $idStatus = 3;
                    	} 
                    	else {
                    	    $idStatus = 1;
                    	}
                    	
                        $this->atualizaNSUNFe('', $data["DATAHORACERTA"], $infEvento["dhRegEvento"], $chave, $infEvento["cStat"], $infEvento["xMotivo"], $infEvento["xMotivo"], 'S', $infEvento["nProt"], $cnpj, $infEvento["tpAmb"], $notaFiscal["NSU"], $idStatus, $infEvento["tpEvento"], $infEvento["nSeqEvento"], $notaFiscal["doc"]);
                    	$tipoEvento = true;
                    }
                    // ResNFe
                    else if(strtolower(substr($notaFiscal["schema"], 0, 6)) == strtolower('resNFe')) {
                    	$chave = $nota["chNFe"];
                        $this->atualizaNSUNFe('', $data["DATAHORACERTA"], $nota["dhRecbto"], $chave, $cStat, $xMotivo, 'Resumo da NF-e', 'S', $nota["nProt"], $cnpj, $object_config->tpAmb, $notaFiscal["NSU"], $nota["cSitNFe"], '', '', $notaFiscal["doc"]);
                    	$tipoRes = true;
                    	
                    	if(!isset($this->chaves[$chave])) {
            			    $this->chaves[$chave] = $chave; //Apenas notas do tipo "ResNFe" são consideradas para retorno.
            			}
                    }
                    // ProcNFe
                    else if(strtolower(substr($notaFiscal["schema"], 0, 7)) == strtolower('procNFe')) {
                    	$infProt = $nota["protNFe"]["infProt"];
                        $chave = $infProt["chNFe"];
                        $this->atualizaNSUNFe('', $data["DATAHORACERTA"], $infProt["dhRecbto"], $chave, $infProt["cStat"], $infProt["xMotivo"], 'NF-e Processada', 'S', $infProt["nProt"], $cnpj, $infProt["tpAmb"], $notaFiscal["NSU"], '1', '', '', $notaFiscal["doc"]);       
                    	$tipoNota  = true;
                    }
                    // ResEvento
                    else if(strtolower(substr($notaFiscal["schema"], 0, 9)) == strtolower('resEvento')) {
                        $chave = $nota["chNFe"];
                        $tipoResEv = true;
                        $resEvento = $nota;
                        $this->atualizaNSUNFe('', $data["DATAHORACERTA"], $nota["dhRecbto"], $nota["chNFe"], $cStat, $xMotivo, 'Resumo do Evento da NF-e', 'S', $resEvento["nProt"], $cnpj, $object_config->tpAmb, $notaFiscal["NSU"], '', $resEvento["tpEvento"], $resEvento["nSeqEvento"], $notaFiscal["doc"]);
                    }
        			
                    if($tipoEvento === true || $tipoRes === true) {
                      
                        $notaSincronizada = $this->sincronizacaoCTEFactory->getNotaSincronizada($chave);
                        $somenteXML = $this->sincronizacaoCTEFactory->somenteXML($chave);
                        
                        if($tipoRes) {
                    	    if(!isset($somenteXML[0]) && !isset($notaSincronizada[0])) {
                			    if(!isset($this->notasInexistentes[$chave])) {
                                    $this->notasInexistentes[$chave] = $chave;
                    	        }
                			}
                    	}
                        if(isset($notaSincronizada[0])) {
                        	$this->sincronizacaoCTEFactory->relacionarNF($notaSincronizada[0]["CDFILIAL"], $notaSincronizada[0]["NRLANCTONF"], $notaSincronizada[0]["CDINSCESTA"], $chave);
                        	$this->sincronizadas++;
                        	
                        	if(isset($somenteXML[0])) {
                                $this->sincronizacaoCTEFactory->intg($chave, $chave);
                        	}
                        }
                        else {
                        	if(isset($somenteXML[0])) {
                            	if(!isset($this->importacaoPendente[$chave])) {
                                    $this->importacaoPendente[$chave] = $chave;
                                }
                            	$this->sincronizacaoCTEFactory->intg($chave, $chave);
                        	}
                        }
                    }
                    else {
                    	$this->xmlsNota[$chave] = $notaFiscal["doc"];
                    }
                    
                }*/
            }
        }
        else if($notas["cStat"] == 137) throw new \Exception($notas['xMotivo'], 137); //Nenhum documento localizado.
        else if($notas["cStat"] == 656) throw new \Exception($notas['xMotivo'], 656); //Consumo indevido.
    }
    
    private function insereNsuNfe($cnpj, $tpAmb, $ultNsu, $maxNsu){
        $maxNrNsu = $this->sincronizacaoCTEFactory->maxNrNsu($cnpj, $tpAmb);
        $data = $this->sincronizacaoCTEFactory->getDataHoraCerta();

        if($maxNrNsu == 0) {
            for($i = ($ultNsu - 100); $i <= $maxNsu; $i++) {
                if($i >= 0) {
                    $nsu = str_pad($i, 15, "0", STR_PAD_LEFT);
                    $nsuExiste = $this->sincronizacaoCTEFactory->consultaNsu($cnpj, $tpAmb, $nsu);
    
                    if(empty($nsuExiste)) {
                        $this->sincronizacaoCTEFactory->insereNsuNfe($cnpj, $tpAmb, $nsu, $data["DATAHORACERTA"], $data["DATAHORACERTA"], '', '', '', '', 'N', '', '', '', '', '', $this->environment->getNrOrgTrab());
                    }
                }
            }
        }
        else {
            for($i = $maxNrNsu; $i <= $maxNsu; $i++) {
                $nsu = str_pad($i, 15, "0", STR_PAD_LEFT);
                $nsuExiste = $this->sincronizacaoCTEFactory->consultaNsu($cnpj, $tpAmb, $nsu);
                if(empty($nsuExiste)) {
                    $this->sincronizacaoCTEFactory->insereNsuNfe($cnpj, $tpAmb, $nsu, $data["DATAHORACERTA"], $data["DATAHORACERTA"], '', '', '', '', 'N', '', '', '', '', '', $this->environment->getNrOrgTrab());
                }
            }
        }

    }
    
    private function atualizaNsuNfe($dtinsnrnsu, $dtupdnrnsu, $dtrecebto, $nracessonfe, $cdstatus, $dsmotivo, $dsservico, $idconsultado, $nrprotocolo, $nrinsjuriest, $tpamb, $nrnsu, $idstatusnfe, $cdservico, $nrseqservico, $xml) {
        $dtrecebto = date('d/m/Y H:i:s', strtotime(substr($dtrecebto, 0, 19)));
        $this->sincronizacaoCTEFactory->atualizaNsuNfe($dtinsnrnsu, $dtupdnrnsu, $nracessonfe, $cdstatus, $dsmotivo, $dsservico, $idconsultado, $dtrecebto, $nrprotocolo, $idstatusnfe, $cdservico, $nrseqservico, $nrinsjuriest, $tpamb, $nrnsu);
        
        if($xml) {
            if(!$this->sincronizacaoCTEFactory->existeXmlNsu($nrinsjuriest, $tpamb, $nrnsu)) {
                $this->sincronizacaoCTEFactory->insereXmlNsu($nrinsjuriest, $tpamb, $nrnsu, $xml, $this->environment->getNrOrgTrab());
            }
        }
    }
    
    private function atualizaNSUFaltante($cnpj, $tpAmb, $nsu) {
        
        $maxNrNsu = $this->sincronizacaoCTEFactory->maxNrNsu($cnpj, $tpAmb);
        
        if($maxNrNsu > 0) {
            $prxNrNSU = ltrim($nsu, "0");
            
            for($i = ($maxNrNsu + 1); $i <= ($prxNrNSU - 1); $i++) {
                
                $dadosCte = [
                    "NSU"          => str_pad($i, 15, "0", STR_PAD_LEFT), "DSSTATUS"     => "NSU inexistente no Sistema Teknisa",
                    "CDSTATUS"     => "999", "NRACESSOCTE"  => null,      "NRINSJURPESQ" => $cnpj, "IDTPAMBIENTE" => $tpAmb,
                    "DTEMISSAO"    => null,  "VRTOTALPREST" => null,      "VRRECEBER"    => null,  "NRINSJUREMIT" => null, 
                    "NMRAZSOCEMIT" => null,  "NRINSJURREME" => null,      "NMRAZSOCREME" => null,  "NRINSJUREXPE" => null, 
                    "NMRAZSOCEXPE" => null,  "NRINSJURRECE" => null,      "NMRAZSOCRECE" => null,  "NRINSJURDEST" => null, 
                    "NMRAZSOCDEST" => null,  "IDTOMADOR"    => null,      "NRINSJURTOMA" => null,  "NMRAZSOCTOMA" => null];
                
                $this->sincronizacaoCTEFactory->incluirNotaCte($dadosCte);
            }
        }
    }
    
    public function setAgendamentoManifestacao($nrorg, $useVpd) {
        if($useVpd){
            $newEntityManager = $this->connectionCustom->updateVpdConnection($nrorg);
            
            if(empty($newEntityManager)) throw new \Exception('Falha ao gerar o newEntityManager.');
            
            $this->entityManager = $newEntityManager;
            $this->novoCodigo = new NewCode($newEntityManager->getConnection(), 'NOVO_CODIGO_SC');
        }
        
        $this->environment->setNrOrg($nrorg);
        $this->environment->setNrOrgTrab($nrorg);
        $this->environment->setCurrentUserId('AUTOMATICO');
        $this->sincronizacaoCTEFactory->setAgendamentoManifestacao($nrorg, $useVpd, ($useVpd) ? $newEntityManager : null);
    }
    
    public function getManifestacaoFactory() {
        return $this->sincronizacaoCTEFactory;
    }
    
    public function getNewEntityManager() {
        return $this->entityManager;
    }
    
    private function replaceCharsForParserInverted($string)
    {
        $from = [
            "&lt;",
            "&gt;",
            "&amp;",
            "&quot;",
            "&#39;"
        ];
        
        $to = [
            "<",
            ">",
            "&",
            "\"",
            "''"
        ];

        return str_replace($from, $to, $string);
    }
}
